/[gentoo-x86]/eclass/wxwidgets.eclass
Gentoo

Contents of /eclass/wxwidgets.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.15 - (show annotations) (download)
Sat Mar 18 16:43:20 2006 UTC (8 years, 9 months ago) by flameeyes
Branch: MAIN
Changes since 1.14: +5 -2 lines
Centralize --as-needed filtering in wxwidgets eclass, safer and simpler.

1 # Copyright 1999-2005 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/wxwidgets.eclass,v 1.14 2005/11/26 20:42:54 sekretarz Exp $
4 #
5 # Author Rob Cakebread <pythonhead@gentoo.org>
6
7 # This eclass helps you find the correct wx-config script so ebuilds
8 # can use gtk, gtk2 or gtk2+unicode versions of wxGTK
9
10 # FUNCTIONS:
11 # need-wxwidgets:
12 # Arguments:
13 # 2.4: gtk gtk2 unicode
14 # 2.6: gtk gtk2 unicode base base-unicode mac mac-unicode
15 #
16 #
17 # set-wxconfig
18 # Arguments: (wxGTK 2.4) wxgtk, wxgtk2, or wxgtk2u
19 # Arguments: (wxGTK 2.6) gtk-ansi gtk2-ansi unicode base-ansi base-unicode mac-ansi mac-unicode
20 # Note: Don't call this function directly from ebuilds
21
22 inherit multilib flag-o-matic
23
24 need-wxwidgets() {
25 debug-print-function $FUNCNAME $*
26 #If you want to use wxGTK-2.6* export WX_GTK_VER in your ebuild:
27 if [ "${WX_GTK_VER}" = "2.6" ]; then
28 case $1 in
29 gtk) set-wxconfig gtk-ansi;;
30 gtk2) set-wxconfig gtk2-ansi;;
31 unicode) set-wxconfig gtk2-unicode;;
32 base) set-wxconfig base-ansi;;
33 base-unicode) set-wxconfig base-unicode;;
34 mac) set-wxconfig mac-ansi;;
35 mac-unicode) set-wxconfig mac-unicode;;
36 *) echo "!!! $FUNCNAME: Error: wxGTK was not comipled with $1."
37 echo "!!! Adjust your USE flags or re-emerge wxGTK with version you want."
38 exit 1;;
39 esac
40
41 else
42 WX_GTK_VER="2.4"
43 case $1 in
44 gtk) set-wxconfig wxgtk;;
45 gtk2) set-wxconfig wxgtk2;;
46 unicode) set-wxconfig wxgtk2u;;
47 *) echo "!!! $FUNCNAME: Error: wxGTK was not compiled with $1."
48 echo "!!! Adjust your USE flags or re-emerge wxGTK with the version you want."
49 exit 1;;
50 esac
51 fi
52
53 filter-ldflags -Wl,--as-needed --as-needed
54 filter-flags -Wl,--as-needed --as-needed
55 }
56
57
58 set-wxconfig() {
59
60 debug-print-function $FUNCNAME $*
61
62 if [ "${WX_GTK_VER}" = "2.6" ] ; then
63 wxconfig_prefix="/usr/$(get_libdir)/wx/config"
64 wxconfig_name="${1}-release-${WX_GTK_VER}"
65 wxconfig="${wxconfig_prefix}/${wxconfig_name}"
66 wxconfig_debug_name="${1}-debug-${WX_GTK_VER}"
67 wxconfig_debug="${wxconfig_prefix}/${wxconfig_debug_name}"
68 else
69 # Default is 2.4:
70 wxconfig_prefix="/usr/bin"
71 wxconfig_name="${1}-${WX_GTK_VER}-config"
72 wxconfig="${wxconfig_prefix}/${wxconfig_name}"
73 wxconfig_debug_name="${1}d-${WX_GTK_VER}-config"
74 wxconfig_debug="${wxconfig_prefix}/${wxconfig_debug_name}"
75 fi
76
77 if [ -e ${wxconfig} ] ; then
78 export WX_CONFIG=${wxconfig}
79 export WX_CONFIG_NAME=${wxconfig_name}
80 export WXBASE_CONFIG_NAME=${wxconfig_name}
81 echo " * Using ${wxconfig}"
82 elif [ -e ${wxconfig_debug} ] ; then
83 export WX_CONFIG=${wxconfig_debug}
84 export WX_CONFIG_NAME=${wxconfig_debug_name}
85 export WXBASE_CONFIG_NAME=${wxconfig_debug_name}
86 echo " * Using ${wxconfig_debug}"
87 else
88 echo "!!! $FUNCNAME: Error: Can't find normal or debug version:"
89 echo "!!! $FUNCNAME: ${wxconfig} not found"
90 echo "!!! $FUNCNAME: ${wxconfig_debug} not found"
91 case $1 in
92 wxgtk) echo "!!! You need to emerge wxGTK with wxgtk1 in your USE";;
93 wxgtkd) echo "!!! You need to emerge wxGTK with wxgtk1 in your USE";;
94 gtk-ansi) echo "!!! You need to emerge wxGTK with wxgtk1 in your USE";;
95 gtkd-ansi) echo "!!! You need to emerge wxGTK with wxgtk1 in your USE";;
96
97 wxgtk2) echo "!!! You need to emerge wxGTK with gtk2 in your USE";;
98 wxgtk2d) echo "!!! You need to emerge wxGTK with gtk2 in your USE";;
99 gtk2-ansi) echo "!!! You need to emerge wxGTK with gtk2 in your USE";;
100 gtk2d-ansi) echo "!!! You need to emerge wxGTK with gtk2 in your USE";;
101
102 wxgtk2u) echo "!!! You need to emerge wxGTK with unicode in your USE";;
103 wxgtk2ud) echo "!!! You need to emerge wxGTK with unicode in your USE";;
104 gtk2-unicode) echo "!!! You need to emerge wxGTK with unicode in your USE";;
105 gtk2d-unicode) echo "!!! You need to emerge wxGTK with unicode in your USE";;
106 esac
107 exit 1
108 fi
109 }

  ViewVC Help
Powered by ViewVC 1.1.20